{ ****************************************************************************
  `StrConv' - ASCIIZ string conversion (Borland Turbo Pascal 5.5 unit)

  Written by Robert Riebisch <rr@bttr-software.de>
  for BTTR Software

  (based on a source code snippet from Sean L. Palmer <?>)

  Copyright (c) 1997-2003 BTTR Software
  All rights reserved.

  This program is free software; you can redistribute it and/or modify it
  under the terms of the `MODIFIED' BSD LICENSE.

  See `legal.txt' for details.
  **************************************************************************** }

{.$DEFINE DEBUG}

{$IFDEF DEBUG}
  {$A+,B-,D+,E-,F-,I-,L+,N-,O-,R+,S+,V+}
{$ELSE}
  {$A+,B-,D-,E-,F-,I-,L-,N-,O-,R-,S-,V+}
{$ENDIF}

unit strconv;

interface

{ convert Pascal string to C (ASCIIZ) string }
procedure strpastoc(var s);

{ convert C (ASCIIZ) string to Pascal string }
procedure strctopas(var s);

implementation

procedure strpastoc(var s);
begin
  inline(
    $1e/          { push ds      ; save DS }
    $c5/$76/<s/   { lds si, [s]  ; load address of string to DS:SI }
    $c4/$7e/<s/   { les di, [s]  ; load address of string to ES:DI }
    $fc/          { cld          ; increment SI/DI after `lodsb'/`movsb' }
    $ac/          { lodsb        ; get length of string }
    $88/$c1/      { mov cl, al   ; put length to CL }
    $30/$ed/      { xor ch, ch   ; CH = 0 }
    $f3/$a4/      { rep movsb    ; copy the whole string one byte down }
    $91/          { xchg cx, ax  ; AL = 0 }
    $aa/          { stosb        ; put ASCIIZ delimiter }
    $1f           { pop ds       ; restore DS }
  );
end;

procedure strctopas(var s);
begin
  inline(
    $1e/         { push ds      ; save DS }
    $c5/$76/<s/  { lds si, [s]  ; load address of string to DS:SI }
    $89/$f7/     { mov di, si   ; save offset for later }

{ @l1: }
    $86/$04/     { xchg al, [si]  ; swap AL (last char) for new char }
    $46/         { inc si         ; point to next char }
    $84/$c0/     { test al, al    ; check for ASCIIZ delimiter }
    $75/$f9/     { jnz @l1        ; not? then start over }

    $96/         { xchg si, ax   ; get new offset }
    $29/$f8/     { sub ax, di    ; subtract old offset }
    $48/         { dec ax        ; -1, Voila! }
    $88/$05/     { mov [di], al  ; store length }
    $1f          { pop ds        ; restore DS }
  );
end;

end.